removeSamples <- function(...)		 
{
	args <- list(...)
	select <- NULL
	##### below needed for wrapping in GP #####
	for(i in 1:length(args)) 
		{
		flag <- substring(args[[i]], 0, 2)
		value <- substring(args[[i]], 3, nchar(args[[i]]))
		if(flag=='-g')
			{
			gct.file <- value;
			}else if(flag=='-r') {
			removelist<- value
			}else if(flag=='-e') {
			extension<- value
			}else if(flag=='-l') {
			libdir <- value
			}else {
			stop("ERROR: input option not recognized!")
			}
		}
	#############################################

### Debugging flags:
debug.skip.regression <- FALSE
debug.verbose.output <- TRUE
if (debug.verbose.output) { paste("Hello world: ", date()) }
###----------------------------------------------------------------------------
### function dprint()
###----------------------------------------------------------------------------
### Outputs its arguments in an informative way, but only if the global flag
### `debug.verbose.output` is set.
dprint <- function(...) {
  if (debug.verbose.output) {
    print(paste(collapse="",
                  c("DEBUG: ", format(Sys.time(), "%H:%M:%S: "), ...)))
  }
}


### load relevant libraries or install if needed
	dprint("Loading libraries.")
	source(paste(libdir, "common2.R", sep=''))
	setLibPath(libdir)
	
dprint("Reading gct file.")
### Read gct file 
	dataset <- MSIG.Gct2Frame(filename = gct.file)
###m2 has the actual scores from the gct file
	m2 <- data.matrix(dataset$ds)
	gctnames<-names(dataset$ds)
	shrnas <- dataset$row.names

dprint("Reading samples to remove file.")	
	rl <- read.delim(removelist, header=F, row.names=1,  sep="\t", blank.lines.skip=T, comment.char="", as.is=T, na.strings = "", check.names=FALSE)
	samples <- row.names(rl)
	#samples <- rl[,1]
	
	keep<-gctnames[!gctnames %in% samples]
	tlist <- !gctnames %in% samples
	dprint("Samples to keep")
	dprint(keep)

gct<-{}	
	gct$data<-m2[,tlist]	
	gct$row.descriptions<-shrnas
	gct$rows<-shrnas
	
### Write out .gct file	
	filename<-paste(extension, ".rnai.gct", sep='')
	rows <- dim(gct$data)[1]
	columns <- dim(gct$data)[2]
	m <- cbind(gct$rows, gct$row.descriptions, gct$data)
	f <- file(filename, "w")
	on.exit(close(f))
	cat("#1.2", "\n", file=f, append=TRUE, sep="")
	cat(rows, "\t", columns, "\n", file=f, append=TRUE, sep="")
	cat("Name", "\t", file=f, append=TRUE, sep="")
	cat("Description", file=f, append=TRUE, sep="")
	names <- colnames(gct$data)

	for(j in 1:length(names)) {
		cat("\t", names[j], file=f, append=TRUE, sep="")
	}
	cat("\n", file=f, append=TRUE, sep="")
	
write.table(m, file=f, append=TRUE, quote=FALSE, na="NaN",sep="\t", col.names=FALSE, row.names=FALSE)
	}